Module Module1

    ' Example program for retrieving samples from TMSI frontends, using bluetooth
    ' Make sure that you have added PortiSerial.dll to the registry using Regsvr32.exe
    ' Make sure that you have added PortiSerial.dll in VisualStudio under References
    Friend AxSerialSource1 As PORTISERIALLib.ISerialSource

    Sub Main()

        Dim AxSerialSource1 As New PORTISERIALLib.SerialSourceClass
        Dim SerialError As Single       ' Error variable for the communication
        Dim samples As Object               ' The recieved samples form the amplifier
        Dim Periods As Integer              ' Number of periods recieved
        Dim NrOfChannels As Integer         ' Number of channels
        Dim SerialNumber As Integer         ' Serial number of the device
        Dim HighestSampleRate As Integer        ' Maximum samplerate of the device
        Dim DesiredSampleRate As Integer        ' Desired samplerate of the device
        Dim RequestedSamples As Integer     ' Number of samples wanted

        Dim BlockTypeSend As Integer
        Dim BlockTypeWaitFor As Integer
        Dim NrOfWordsSend As Integer
        Dim NrOfWordsRecieve As Integer
        Dim DataToSend(10) As Integer
        Dim RecieveDataBuffer(100) As Integer

        ' After setting up the bluetooth connection with the frontend,
        ' set up the serial connection. After this is done, Windows XP 
        ' will show the com port number which is used for the serial 
        ' connection.
        ' Fill in the number of the com port 
        AxSerialSource1.ComPort = "4"

        ' Now test if front end is there
        ' when an answer is recieved, the serialnumber must match with the 
        ' serialnumber (labeled SN) on the silver label on the frontend
        SerialNumber = AxSerialSource1.FrontendSerialNumber()
        If SerialNumber = -1 Then
            'Can't open data connection to sampling device
            Exit Sub
        End If

        ' Get the number of channels of this frontend
        AxSerialSource1.GetFrontendNrOfChannels(NrOfChannels)

        BlockTypeSend = 34
        BlockTypeWaitFor = 35
        NrOfWordsSend = 0
        NrOfWordsRecieve = 100
        DataToSend(0) = 0
        DataToSend(1) = 10
        AxSerialSource1.TestBlock(BlockTypeSend, BlockTypeWaitFor, NrOfWordsSend, NrOfWordsRecieve, DataToSend(0), RecieveDataBuffer(0))

        ' Get the highest samplerate of this frontend
        HighestSampleRate = AxSerialSource1.SampleRate()

        ' Set the desired samplerate
        DesiredSampleRate = HighestSampleRate / 4
        AxSerialSource1.SampleRate = DesiredSampleRate

        ' Start the measurement
        AxSerialSource1.StartAcq(DesiredSampleRate, SerialError)

        ' First get the number of recieved periods and relevant data
        While RequestedSamples < 1000
            AxSerialSource1.GetSampleRecordAsVariant(Periods, samples)
            RequestedSamples += Periods
        End While

        ' Now close the measurement
        AxSerialSource1.StopAcq(SerialError)
        AxSerialSource1.ReleaseSerialPort(SerialError)

    End Sub

End Module
